/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "zeroII_i2c.h"
#include "stdio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
 I2C_HandleTypeDef hi2c1;

/* USER CODE BEGIN PV */
#define debug_out(X)		HAL_Delay(1);

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_I2C1_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */

  uint32_t frequency = 100000000; 	// 100 MHz
  float systemZ0 = 50.0; 			// Ohm

  const ZEROII_RESULT_t* hresult = 0;
  const ZEROII_DEV_INFO_t* hdev_info = 0;

  char msg_buf[256] = {0};

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

	zeroII_init(&hi2c1, GPIOB, GPIO_PIN_5);

	hdev_info = zeroII_get_info();
	if (hdev_info)
	{
		sprintf(msg_buf, "FW ver.%u.%u HW rev.%u SerialNum %lu",
				hdev_info->version_maj, hdev_info->version_min, hdev_info->version_rev, hdev_info->zeroII_serial);
		debug_out(msg_buf);
	}

	systemZ0 = zeroII_get_system_z();
	if (systemZ0)
	{
		sprintf(msg_buf, "Get System Z0 = %4.2f", systemZ0);
		debug_out(msg_buf);
	}

	systemZ0 = 75.0;

	if (zeroII_set_system_z(systemZ0))
	{
		sprintf(msg_buf, "Set System Z0 = %4.2f", systemZ0);
		debug_out(msg_buf);
	}

	if (zeroII_measure_RX(frequency))
	{
		hresult = zeroII_wait_until_ready(300); // Blocking mode
		if (hresult)
		{
			sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm @ %lu Hz",
					hresult->R, hresult->X, frequency);
			debug_out(msg_buf);
		}
	}

	if (zeroII_measure_RX_SWR_RL(frequency))
	{
		hresult = zeroII_wait_until_ready(300); // Blocking mode
		if (hresult)
		{
			sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm, SWR = %3.2f, RL = %3.2f dB @ %lu Hz",
					hresult->R, hresult->X, hresult->SWR, hresult->RL, frequency);
			debug_out(msg_buf);
		}
	}

	if (zeroII_measure_RX(frequency))
	{
		do
		{
			asm("NOP"); // Do something useful

			hresult = zeroII_is_ready(); // Non-blocking mode
			if (hresult)
			{
				sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm @ %lu Hz",
						hresult->R, hresult->X, frequency);
				debug_out(msg_buf);
				break; // Exit the loop
			}
		} while (1);
	}

	if (zeroII_measure_RX_SWR_RL(frequency))
	{
		do
		{
			asm("NOP"); // Do something useful

			hresult = zeroII_is_ready(); // Non-blocking mode
			if (hresult)
			{
				sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm, SWR = %3.2f, RL = %3.2f dB @ %lu Hz",
						hresult->R, hresult->X, hresult->SWR, hresult->RL, frequency);
				debug_out(msg_buf);
				break; // Exit the loop
			}
		} while (1);
	}

	for (uint8_t i = 0; i < 20; i++)
	{
		if (zeroII_remeasure_RX())
		{
			hresult = zeroII_wait_until_ready(300); // Blocking mode
			if (hresult)
			{
				sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm @ %lu Hz",
						hresult->R, hresult->X, frequency);
				debug_out(msg_buf);
			}
		}
		HAL_Delay(1); //Put breakpoint here to check result
	}

	for (uint8_t i = 0; i < 20; i++)
	{
		if (zeroII_remeasure_RX_SWR_RL())
		{
			hresult = zeroII_wait_until_ready(300); // Blocking mode
			if (hresult)
			{
				sprintf(msg_buf, "R = %5.3f Ohm, X = %5.3f Ohm, SWR = %3.2f, RL = %3.2f dB @ %lu Hz",
						hresult->R, hresult->X, hresult->SWR, hresult->RL, frequency);
				debug_out(msg_buf);
			}
		}
		HAL_Delay(1); //Put breakpoint here to check result
	}

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 100000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
